#define SSR
#define SSRBiscard
#define SSRBiscardTimes 6//[3 4 5 6 7 8 9 10 11 12]
#define SSRTracTimes 128//[12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 64 128]

float ExpToLinearDepth(in float depth)
{
    return (2.0 * near) / (far + near - depth * (far - near));
}

vec3 RayTracTexcoord(in vec3 start, vec3 dir, in float dither)
{
    vec3 test = start;
    dir *= 0.05;
    vec3 result;
    for(int i = 0;i < SSRTracTimes;i++)
    {
        vec3 tracStep = dir * pow(i + 1 + dither, 1.46);
        test += tracStep;
        vec3 pos = View2Proj(test);
        if(abs(pos.x) > 1 || abs(pos.y) > 1 || abs(pos.z) > 1)
            break;
        pos = pos * 0.5 + 0.5;
        float sampleDepth = texture(depthtex0, pos.xy).x;
        if(pos.z > sampleDepth + 0.0001 && ExpToLinearDepth(pos.z) - ExpToLinearDepth(sampleDepth) < (1.0 / 2048.0) * (1.0 + ExpToLinearDepth(pos.z) * 200.0 + i))
        {
            #ifdef SSRBiscard
                for(int j = 0;j < SSRBiscardTimes;j++)
                {
                    tracStep *= 0.5;
                    sampleDepth = texture(depthtex0, pos.xy).x;
                    test += tracStep * sign(sampleDepth - pos.z);
                    pos = View2Proj(test) * 0.5 + 0.5;
                }
            #endif
            
            result = vec3(pos.xy, float(int(texture(colortex2, pos.xy).x * 255.0 + 0.0001) == 1));
            
            break;
        }
    }
    return result;
}